--variables
pressMouse = true
pressKey = true
currentId = 0
currentSid = 0
currentInvert = false
screen = 0
idName = ''
fullscreen = false
alpha = true
timer = 0
tilesCount = 0
performanceString = ''

--tables
tiles = {}
bgt = {}
mouse = {x = 0, y = 0}

function fillbg()	--functions
	fx = 0
	fy = 0
	while fy < 720 do
		if fx < 1280 then
			newBg = {x = fx, y = fy, c = fc} table.insert(bgt, newBg)
			fx = fx + 40
		end
		if fx > 1280 or fx == 1280 then
			fx = 0
			fy = fy + 40
		end
	end
end


function love.load(arg)
	love.mouse.setVisible(false)

	if levelString == nil then
		levelString = ''
	end

	exist = love.filesystem.exists('level.txt')
	if exist == false then
		file = love.filesystem.newFile('level.txt')
		love.filesystem.write('level.txt', 1)
		print('level does not exist, created new file')
	end
	
	cursorImg = love.graphics.newImage('cursor.png')
	
	require('load')
	fillbg()
end

function love.update(dt)
	hdt = dt

	--update mouse
	mouse.x = love.mouse.getX()
	mouse.y = love.mouse.getY()
	
	--remove tiles at same pos
	for i, tile in pairs(tiles) do
		for j, tile2 in pairs(tiles) do
			
		end
	end
	
	--timer
	timer = timer + hdt
	
	--input
	if love.keyboard.isDown('lshift') and pressKey then
		pressKey = false
		if currentInvert then
			currentInvert = false
		else
			currentInvert = true
		end
	end
	
	
	if love.keyboard.isDown('lctrl') and love.keyboard.isDown('p') and pressKey then	--compile
		tilesCount = 0
		levelString = ''
		for i, tile in pairs(tiles) do
			levelString = levelString.. 'newTile = {x = '.. tile.x.. ', y = '.. tile.y.. ', id = '.. tile.id.. ', sid = '.. tile.sid.. ', invert = '.. tostring(tile.invert).. ', name = '.. tile.name.. '} table.insert(tiles, newTile) '
			print('counting tiles... currently there are '..i..' tiles registered')
			if i > tilesCount then
				tilesCount = i
			end
		end
		print('--------------------------------------------------------------------------------')
		print('wrote leveldata to level.txt')
		print('total amount of tiles: '..tilesCount)
		if tilesCount < 100 then
			performanceString = 'Fantastic'
		elseif tilesCount < 175 then
			performanceString = 'Great'
		elseif tilesCount < 225 then
			performanceString = 'Good'
		elseif tilesCount < 300 then
			performanceString = 'Decent'
		elseif tilesCount < 350 then
			performanceString = 'Bad'
		elseif tilesCount < 425 then
			performanceString = 'Very bad'
		else
			performanceString = 'Really,really,really bad'
		end
		print('Predicted performance: '.. performanceString)
		
		love.filesystem.write('level.txt', tostring(levelString))
		pressKey = false
	end
	
	if love.keyboard.isDown('lctrl') and love.keyboard.isDown('i') and pressKey then	--import
		pressKey = false
		loadTiles()
		print('imported tiles from load.lua')
	end
	
	if love.mouse.isDown('1','2') then	--placing 
		if pressMouse and love.mouse.isDown('1') then
			pressMouse = false
			newTile = {x = (math.floor(mouse.x/40)*40)+(1280*screen), y = math.floor(mouse.y/40)*40, id = currentId, sid = currentSid, invert = currentInvert, name = idName, t = timer} table.insert(tiles, newTile)
		end
	else
		pressMouse = true
	end

	if love.mouse.isDown('2') and pressMouse then	--removing
		for i, tile in pairs(tiles) do
			if tile.x == math.floor(mouse.x/40)*40+(1280*screen) and tile.y == math.floor(mouse.y/40)*40 then
				table.remove(tiles, i)
			end
		end
	end

	if love.keyboard.isDown('a') and pressKey then	--id changing
		pressKey = false
		currentId = currentId - 1
	elseif love.keyboard.isDown('d') and pressKey then
		pressKey = false
		currentId = currentId + 1
	end

	if love.keyboard.isDown('z') and pressKey then	--subid changing
		pressKey = false
		currentSid = currentSid - 1
	elseif love.keyboard.isDown('c') and pressKey then
		pressKey = false
		currentSid = currentSid + 1
	end
	
	if love.keyboard.isDown('tab') and pressKey then
		if currentId > 100 or currentId == 100 then
			currentId = currentId - 100
		elseif currentId < 100 then
			currentId = currentId + 100
		end
		pressKey = false
	end

	if love.keyboard.isDown('e') and pressKey then	--screen swap
		pressKey = false
		screen = screen + 1
	elseif love.keyboard.isDown('q') and pressKey then
		pressKey = false
		screen = screen - 1
	end
	
	if love.keyboard.isDown('+') and pressKey then
		pressKey = false
		if alpha then
			alpha = false
		else
			alpha = true
		end
	end
	
	if love.keyboard.isDown('f1') and pressKey then
		pressKey = false
		if fullscreen then
			fullscreen = false
		else
			fullscreen = true
		end
		love.window.setFullscreen(fullscreen)
	end
	
	if love.keyboard.isDown('escape') then
		love.event.quit()
	end
	
	if love.keyboard.isDown('a','d','p','e','q','i','f1','z','c','x','lshift','tab','+') then	--reseting pressKey
		
	else
		pressKey = true
	end
	
	if currentId == 0 then		--Id name updating
		idName = 'frame'
	elseif currentId == 1 then
		idName = 'spikes'
	elseif currentId == 2 then
		idName = 'fall'
	elseif currentId == 3 then
		idName = 'jPad'
	elseif currentId == 4 then
		idName = 'kBox'
	elseif currentId == 5 then
		idName = 'crate'
	elseif currentId == 100 then
		idName = 'rLaser'
	elseif currentId == 101 then
		idName = 'mGun'
	elseif currentId == 102 then
		idName = 'hmng'
	else
		idName = '"n/a"'
	end
	
end

function love.draw(dt)
	love.graphics.scale(love.graphics.getWidth()/1280,love.graphics.getHeight()/720)	--scale

	for i, bg in pairs(bgt) do		--bg objects
		love.graphics.setColor(0,0,0)
		love.graphics.rectangle('fill', bg.x, bg.y, 40, 40)
		love.graphics.setColor(50,50,50)
		love.graphics.rectangle('fill', bg.x+1, bg.y+1, 39, 39)
	end
	
	--helpers
	for i, tile in pairs(tiles) do
		if tile.id > 99.9 then		--enemy tiles circle
			love.graphics.setColor(255,50,50,20)
			love.graphics.circle('fill',tile.x+20,tile.y+20,250,30)
		elseif tile.id == 2 then
			love.graphics.setColor(18,18,255,255)
			love.graphics.rectangle('fill',tile.x,tile.y,40,40)
		elseif tile.id == 3 then
			love.graphics.setColor(255,255,0,100)
			love.graphics.line(tile.x+20,tile.y+40,tile.x+20,tile.y+40-(40*7))
		end
	end
	
	for i, tile in pairs(tiles) do		--tiles
		if tile.name == nil then
			tile.name = 'err'
		end
		if tile.id > 99.9 then
		love.graphics.setColor(255,100,100)
		elseif tile.id == 1 then
		love.graphics.setColor(140,140,140)
		elseif tile.id == 2 then
		love.graphics.setColor(100,100,255)
		elseif tile.id == 3 then
		love.graphics.setColor(255,255,100)
		elseif tile.id == 4 then
		love.graphics.setColor(100,100,100)
		elseif tile.id == 5 then
		love.graphics.setColor(142*1.5,86*1.5,48*1.5)
		else
		love.graphics.setColor(255,255,255)
		end
		love.graphics.rectangle('fill', tile.x-(screen*1280), tile.y, 40, 40)
		love.graphics.setColor(50,50,50,255)
		love.graphics.print(tile.id, tile.x-(screen*1280), tile.y)
		love.graphics.setColor(50,90,50,255)
		love.graphics.print(tile.name, tile.x-(screen*1280),tile.y+10)
		love.graphics.setColor(90,50,50,255)
		--love.graphics.print(tostring(tile.invert), tile.x-(screen*1280),tile.y+25)
	end
	
	if alpha then		--text
		love.graphics.setColor(20,20,20,150)
	else
		love.graphics.setColor(20,20,20,255)
	end
	love.graphics.rectangle('fill', 0, 0, 120, 70)
	
	love.graphics.setColor(100,100,255)		
	if currentId > 100 or currentId == 100 then
		love.graphics.print('"'.. idName.. '"', 55,10)
	else
		love.graphics.print('"'.. idName.. '"', 40,10)
	end
	
	love.graphics.setColor(100,100,255)
	love.graphics.print('Id: '.. currentId, 10,10)
	love.graphics.setColor(100,100,255)
	love.graphics.print('subId: '.. currentSid, 10,25)
	love.graphics.setColor(100,100,255)
	love.graphics.print('screen: '.. screen, 10,40)
	love.graphics.setColor(100,100,255)
	--love.graphics.print('currentInvert: '.. tostring(currentInvert), 10,55)
	
	love.graphics.setColor(255,255,255)		--mouse
	love.graphics.draw(cursorImg, mouse.x, mouse.y)
end