--variables
gravity = 350
fullscreen = false
first = true
bgFirst = true
bgx1 = -800
bgx2 = -600
hdt = 0.1
creditsY = 720

--tables
player = {x = 1280/2-20, y = -3000, speed = 350, jump = 0, invincible = false, inCircle = false}
spawn = {x = 50, y = -3000, rot = 0}
endgate = {x = 1100,y = -3000}
col = {up = true, down = true, left = true, right = true}
level = {current = -1, canLoad = true}
timer = {particles = 1}
music = {track1 = 0}
menu = {selected = 1, page = 1}
trans = {timer = 0, x = -6000, canTimer = false, speed = 4500}
options = {info = false, particles = true, masterVolume = 0.5, musicVolume = 0.5}
lights = {}
keys = {}
bullets = {}
tiles = {}
bgObjects = {}
particles = {}
boxes = {}





--functions
function collision(x1,y1,h1,w1,x2,y2,h2,w2)
	return x1 < x2+w2 and
		   y1 < y2+h2 and
		   x2 < x1+w1 and
		   y2 < y1+h1
end

function respawn()
	if player.invincible == false then
	freezeFrame()
	playS(s_death)
	n = 20
	while n > 0 and options.particles do
		n = n - 1
		newParticle = {x = player.x+10, y = player.y+10, ydir = math.random(-200,200), xdir = math.random(-200,200), id = 4}
		table.insert(particles, newParticle)
	end
	bullets = {}
	player.x = spawn.x
	player.y = spawn.y-20
	player.jump = 0
	for i, key in pairs(keys) do
		key.exist = true
	end
	for i, tile in pairs(tiles) do
		
		tile.kAlpha = - 600
		tile.timer = 100
		tile.exist = true
		tile.falling = false
		tile.alpha = 255
		
		if tile.px == nil or tile.py == nil then
		else
			tile.x = tile.px
			tile.y = tile.py
		end
	end
	end
end
function math.dist(x1,y1, x2,y2)
	return ((x2-x1)^2+(y2-y1)^2)^0.5 
end
function drawBackground()

--	bgObjects = {}
	canBg = true
	while bgx1 < 1280 do
	--	canBg = true
		if canBg then
			newBgobject = {x = bgx1, id = 0} table.insert(bgObjects, newBgobject)
			bgx1 = bgx1 + 200
		end
	end
	
	if bgx1 < 1280 then
	else
		canBg = false
		bgFirst = false
	end 

	for i, bgObject in pairs(bgObjects) do
		if menu.page == 2 then
			love.graphics.setColor(30*(bgObject.x/720+0.5),30*(bgObject.x/720+0.5),30*(bgObject.x/720+0.5),100)
		else
			love.graphics.setColor(15,15,15,255)
		end
		love.graphics.polygon('fill', 0+bgObject.x,720,100+bgObject.x,0,200+bgObject.x,0,100+bgObject.x,720)
	end

	for i, bgObject in pairs(bgObjects) do
			bgObject.x = bgObject.x + (20*hdt)
		if bgObject.x > 1600 + 200 then
			bgObject.x = -200
		end
	end
	
end
function existFix()
	for i, tile in pairs(tiles) do
		tile.exist = true
	end
	
	--this stuff is just here to make sure homingrockets update accordingly
	for i, tile in pairs(tiles) do
		tile.timer = 100
	end
end
function loadSettings()
	if love.filesystem.exists('fullscreen.txt') then	--fullscreen
		x = love.filesystem.read('fullscreen.txt')
		if tonumber(x) == 0 then
			fullscreen = true
		else
			fullscreen = false
		end
		love.window.setFullscreen(fullscreen)
	else
		love.filesystem.newFile('fullscreen.txt')
		love.filesystem.write('fullscreen.txt', tostring(1))
		love.window.setFullscreen(false)
	end
	
	if love.filesystem.exists('particles.txt') then	--particles
		x = love.filesystem.read('particles.txt')
		if tonumber(x) == 0 then
			options.particles = true
		else
			options.particles = false
		end
	else
		love.filesystem.newFile('particles.txt')
		love.filesystem.write('particles.txt', tostring(options.particles))
	end
	
	if love.filesystem.exists('masterVolume.txt') then	--masterVolume
		options.masterVolume = tostring(love.filesystem.read('masterVolume.txt'))
	else
		love.filesystem.newFile('masterVolume.txt')
		love.filesystem.write('masterVolume.txt', tonumber(options.masterVolume))
	end
end
function playS(sound)
	canPlayS = true
	if sound == nil then
		canPlayS = false
	end
	if canPlayS then
		love.audio.stop(sound)
		love.audio.play(sound)
	end
end
function transi()	
	trans.x = trans.x - (trans.speed*hdt)
	love.graphics.setColor(0,0,0)
	love.graphics.polygon('fill',1280+trans.x,720,1380+trans.x,0,4280+trans.x,0,4180+trans.x,720)
	
	if trans.x < -11000 then
		trans.x = -10001
	end
end
function freezeFrame()
	love.timer.sleep(1/30)
end
function writeData()
	if fullscreen then
		love.filesystem.write('fullscreen.txt', tostring(0))
	else
		love.filesystem.write('fullscreen.txt', tostring(1))
	end
	if options.particles then
		love.filesystem.write('particles.txt', tostring(0))
	else
		love.filesystem.write('particles.txt', tostring(1))
	end
	love.filesystem.write('masterVolume.txt', tostring(options.masterVolume))
end
function raytrace(x1,y1, x2,y2)
	local bx = (x2-x1)/2+x1
	local by = (y2-y1)/2+y1
	local ret = false
	
	for i, tile in pairs(tiles) do
		if collision(bx,by,1,1,tile.x,tile.y,40,40) and tile.id == 0 then
			ret = true
		end
	end
	
	return ret
end

function love.load()
	loadSettings()
	respawn()
	love.mouse.setVisible(false)
	
	--textures
	playerImg = love.graphics.newImage('assets/player/player.png')
	spikesImg = love.graphics.newImage('assets/tiles/spikes.png')
	jumppadImg = love.graphics.newImage('assets/tiles/jumppad.png')
	laserRocketImg = love.graphics.newImage('assets/ents/laserRocket.png')
	machinegunImg = love.graphics.newImage('assets/ents/machinegun.png')
	homingImg = love.graphics.newImage('assets/ents/homing.png')
	spawnImg = love.graphics.newImage('assets/player/spawn.png')
	endImg = love.graphics.newImage('assets/player/end.png')
	linesImg = love.graphics.newImage('assets/tiles/lines.png')
	bgOverlayImg = love.graphics.newImage('assets/bg/bgOverlay.png')
	keyImg = love.graphics.newImage('assets/ents/key.png')
	keyboxImg = love.graphics.newImage('assets/tiles/keybox.png')
	slopeImg = love.graphics.newImage('assets/tiles/slope.png')
	cursorImg = love.graphics.newImage('assets/menu/cursor.png')
	plusminusImg = love.graphics.newImage('assets/menu/plusminus.png')
	logoImg = love.graphics.newImage('assets/menu/logo.png')
	buttonImg = love.graphics.newImage('assets/menu/button.png')
	keyBImg = love.graphics.newImage('assets/menu/key.png')
	--audio
	s_hit1 = love.audio.newSource('assets/audio/hit1.wav')
	s_key = love.audio.newSource('assets/audio/key.wav')
	s_explosion = love.audio.newSource('assets/audio/explosion.wav')
	s_target = love.audio.newSource('assets/audio/target.wav')
	s_jumppad = love.audio.newSource('assets/audio/jumppad.wav')
	s_blip1 = love.audio.newSource('assets/audio/blip1.wav')
	s_blip2 = love.audio.newSource('assets/audio/blip2.wav')
	s_back = love.audio.newSource('assets/audio/back.wav')
	s_death = love.audio.newSource('assets/audio/death.wav')
	s_music1 = love.audio.newSource('assets/audio/music1.mp3')
	s_music2 = love.audio.newSource('assets/audio/music2.mp3')
	--fonts
	f_rog = love.graphics.newFont('assets/menu/fonts/rog.ttf',90*4)
	f_lun = love.graphics.newFont('assets/menu/fonts/lunchds.ttf',90*4)
	f_dv = love.graphics.newFont('assets/menu/fonts/dv.ttf')
	
	
	--load levels
	require('levels/1')
	require('levels/2')
	require('levels/3')
	require('levels/4')
	require('levels/5')
	require('levels/6')
	require('levels/7')
	require('levels/8')
	require('levels/9')
	require('levels/10')
	require('levels/11')
	require('levels/12')
	require('levels/13')
	require('levels/14')
	require('levels/15')
	require('levels/16')
	require('levels/17')
	require('levels/18')
	require('levels/19')
	require('levels/20')
	require('levels/21')
	require('levels/22')
	require('levels/23')
	require('levels/24')
	require('levels/25')
	require('levels/26')
	require('levels/menu')
	require('levels/test')
	
	--load everything else
	require('bin/menu/options')
	require('bin/menu/mainM')
	require('bin/music')
	require('bin/key')
	require('bin/particles')
	require('bin/levels')
	require('bin/input')
	require('bin/player')
	require('bin/tiles')
	require('bin/bullets')
	require('bin/bullets/homingM')
	require('bin/bullets/explosion')
	require('bin/tileSet/spikes')
	require('bin/tileSet/laser')
	require('bin/tileSet/laserRocket')
	require('bin/tileSet/machinegun')
	require('bin/tileSet/homing')
	require('bin/tileSet/fall')
	require('bin/tileSet/jumppad')
	require('bin/tileSet/crate')
	
	
end


function love.update(dt)
	
	for i, tile in pairs(tiles) do
			if tile.id == 100.1 then
				print(i)
			end
		end

	hdt = love.timer.getDelta( )
	
	
	love.graphics.setFont(f_dv)
	
	updateMainM()
	updateOptions()
	updateMusic()
	updateParticles()
	updateLevels()
	updateKey()
	updateHoming()
	updateJumppad()
	updateMachinegun()
	updateExplosion()
	updateLaserRocket()
	updateLaser()
	updateSpikes()
	updateFall()
	updateInput()
	updatePlayer()
	updateTiles()
	updateBullets()
	updateCrate()
	updateHomingM()
	
	first = false
end

function love.draw(dt)

	love.graphics.scale(love.graphics.getWidth()/1280, love.graphics.getHeight()/720)
	love.graphics.setBackgroundColor(10,10,10)
	
	--draw background
	drawBackground()
	
	--Draw Lights
	--for i, light in pairs(lights) do
	--	if light.alpha == nil then
	--		light.alpha = 25
	--	end
	--	love.graphics.setColor(240,240,240,light.alpha)
	--	love.graphics.rectangle('fill',light.x-20,light.y-40,40,40)
	--	love.graphics.polygon('fill',light.x-20,light.y,light.x+20,light.y,light.x+light.spread,720,light.x-light.spread,720)
	--end
	
	--Draw lRocket circle
	for i,tile in pairs(tiles) do
		if tile.id > 99.9 and tile.sdir > 0 or tile.id > 99.9 and math.dist(tile.x+10,tile.y+10,player.x+10,player.y+10) < 250 then
			love.graphics.setColor(25,10,10,255)
			love.graphics.circle('line',tile.x+20,tile.y+20,250,100)
		end
	end
	for i,tile in pairs(tiles) do
		if tile.id > 99.9 and tile.sdir > 0 or tile.id > 99.9 and math.dist(tile.x+10,tile.y+10,player.x+10,player.y+10) < 250 then
			love.graphics.setColor(15,10,10,100)
			love.graphics.circle('fill',tile.x+20,tile.y+20,250,100)
		end
	end
	
	--Draw Homing circle
	for i, bullet in pairs(bullets) do
		if bullet.id == 3 and bullet.showRad then
			love.graphics.setColor(150,10,10,170)
			love.graphics.circle('line',bullet.x,bullet.y,60,40)
			love.graphics.setColor(150,10,10,170)
			love.graphics.circle('line',bullet.x,bullet.y,bullet.rad,40)
			love.graphics.setColor(150/2,10,10,170/1.75)
			love.graphics.circle('line',bullet.x,bullet.y,bullet.rad2-5,40)
			love.graphics.setColor(50,10,10,70)
			love.graphics.circle('fill',bullet.x,bullet.y,60,40)
		end
	end
	
	--Draw Bullets
	for i, bullet in pairs(bullets) do
		if bullet.id == 0 then
			love.graphics.setColor(255,0,0,255)
			love.graphics.circle('fill',bullet.x,bullet.y,4,10)
		elseif bullet.id == 1 then
			
			love.graphics.setColor(255,0,0,bullet.alpha)
			love.graphics.circle('fill',bullet.x,bullet.y,bullet.radius,40)
			love.graphics.setColor(0,0,0,bullet.alpha)
			love.graphics.circle('fill',bullet.x,bullet.y,bullet.radius-2.5,35)
		elseif bullet.id == 2 then
			if bullet.outerCircle == nil then
				bullet.outerCircle = 0
			end
			love.graphics.setColor(255,0,0,255)
			love.graphics.circle('fill',bullet.x,bullet.y,3,35)
			love.graphics.setColor(255/3*2,0,0,255/2)
			love.graphics.circle('line',bullet.x,bullet.y,bullet.outerCircle*1.75,35)
		elseif bullet.id == 3 then
			love.graphics.setColor(255,0,0,255)
			love.graphics.circle('fill',bullet.x,bullet.y,3,35)
			love.graphics.circle('line',bullet.x,bullet.y,6,35)
		end
	end
	
	
	--Draw particles
	for i, particle in pairs(particles) do
		if particle.id == 0 then
			love.graphics.setColor(255,255,255,particle.alpha)
			love.graphics.rectangle('fill',particle.x-0.25,particle.y-0.25,0.5,0.5)
		elseif particle.id == 0.1 then
			love.graphics.setColor(255,255,255,particle.alpha)
			love.graphics.rectangle('fill',particle.x-0.25,particle.y-0.25,0.5,0.5)
		elseif particle.id == 1 then
			love.graphics.setColor(255,255,255,particle.alpha)
			love.graphics.rectangle('fill',particle.x-0.75,particle.y-0.75,1.5,1.5)
		elseif particle.id == 2 then
			love.graphics.setColor(255,0,0,particle.alpha)
			love.graphics.circle('fill',particle.x,particle.y,1.5,15)
		elseif particle.id == 3 then
			love.graphics.setColor(255,0,0,particle.alpha)
			love.graphics.rectangle('fill',particle.x-0.5,particle.y-0.5,1,1)
		elseif particle.id == 4 then
			love.graphics.setColor(255,255,255,particle.alpha)
			love.graphics.rectangle('fill',particle.x-0.5,particle.y-0.5,1,1)
		elseif particle.id == 5 then
			love.graphics.setColor(50,50,255,particle.alpha)
			love.graphics.rectangle('fill',particle.x-0.5,particle.y-0.5,1,1)
		end
	end
	
	
	--Draw key
	for i, key in pairs(keys) do
		if key.exist then
			love.graphics.setColor(255,255,255)
			love.graphics.draw(keyImg,key.x,key.y,0,0.5,0.5)
		end
	end
	
	--Draw spawn
	love.graphics.setColor(255,255,255,255)
	love.graphics.draw(spawnImg, spawn.x-(spawnImg:getWidth()/4)+(playerImg:getWidth()/4),spawn.y,0,0.5,0.5)
	
	--Draw end
	love.graphics.setColor(255,255,255,255)
	love.graphics.draw(endImg, endgate.x-(endImg:getWidth()/4)+(playerImg:getWidth()/4),endgate.y,0,0.5,0.5)
	
	--Draw Tiles
	for i, tile in pairs(tiles) do	--bg
		if tile.id == 0 then
			love.graphics.setColor(0,0,0,255)
			love.graphics.rectangle('fill',tile.x,tile.y,40,40)	
		end
	end
	
	--actual tile drawing
	for i, tile in pairs(tiles) do
		if tile.id == -1 then
			love.graphics.setColor(0,0,255,255)
			love.graphics.rectangle('fill',tile.x,tile.y,40,40)
		end
		if tile.id == 0 then
				
				
			if tile.up then		--draw lines
			else
				love.graphics.setColor(tile.color)
				if tile.right then
					love.graphics.rectangle('fill',tile.x-2,tile.y,42,2)
				elseif left then
					love.graphics.rectangle('fill',tile.x,tile.y,42,2)
				else
					love.graphics.rectangle('fill',tile.x,tile.y,40,2)
				end
			end
			if tile.down then
			else
				love.graphics.setColor(tile.color)
				
				if tile.right then
					love.graphics.rectangle('fill',tile.x-2,tile.y+38,42,2)
				elseif left then
					love.graphics.rectangle('fill',tile.x,tile.y+38,42,2)
				else
					love.graphics.rectangle('fill',tile.x,tile.y+38,40,2)
				end
			end
			if tile.left then
			else
				love.graphics.setColor(tile.color)
				
				if tile.up then
					love.graphics.rectangle('fill',tile.x+38,tile.y-2,2,42)
				elseif tile.down then
					love.graphics.rectangle('fill',tile.x+38,tile.y,2,42)
				else
					love.graphics.rectangle('fill',tile.x+38,tile.y,2,40)
				end
			end
			if tile.right then
			else
				love.graphics.setColor(tile.color)
				
				if tile.up then
					love.graphics.rectangle('fill',tile.x,tile.y-2,2,42)
				elseif tile.down then
					love.graphics.rectangle('fill',tile.x,tile.y,2,42)
				else
					love.graphics.rectangle('fill',tile.x,tile.y,2,40)
				end
					
			end
			
			
			
		end
		if tile.id == 1 then
			love.graphics.setColor(255,255,255,255)
			love.graphics.draw(spikesImg,tile.x,tile.y,0,0.5,0.5)
		end
		if tile.id == 2 then
				
			tile.color = {50,50,255,tile.alpha}
				
			if tile.up then
			else
				love.graphics.setColor(tile.color)
				love.graphics.rectangle('fill',tile.x,tile.y,40,2)
			end
			if tile.down then
			else
				love.graphics.setColor(tile.color)
				love.graphics.rectangle('fill',tile.x,tile.y+38,40,2)
			end
			if tile.left then
			else
				love.graphics.setColor(tile.color)
				love.graphics.rectangle('fill',tile.x+38,tile.y,2,40)
			end
			if tile.right then
			else
				love.graphics.setColor(tile.color)
				love.graphics.rectangle('fill',tile.x,tile.y,2,40)
			end
			
			love.graphics.draw(linesImg,tile.x,tile.y,0,0.5,0.5)
			
		end
		if tile.id == 3 then
			if tile.c > 0 then
				love.graphics.setColor(255,255,255,tile.ac)
				love.graphics.circle('line',tile.x+20,tile.y+30,6*tile.c,30)
				love.graphics.circle('line',tile.x+20,tile.y+30,4*tile.c,30)
				love.graphics.circle('line',tile.x+20,tile.y+30,2*tile.c,30)
			end
			love.graphics.setColor(255,255,255,255)
			love.graphics.draw(jumppadImg, tile.x,tile.y,0,0.5,0.5)
			end
		if tile.id == 4 and tile.exist then
			love.graphics.setColor(255,255,255,255)
			love.graphics.draw(keyboxImg,tile.x,tile.y,0,0.5,0.5)
		elseif tile.id == 4 and tile.exist == false then
			tile.kAlpha = tile.kAlpha + (255*hdt)
			love.graphics.setColor(25,25,25,tile.kAlpha)
			love.graphics.draw(keyboxImg,tile.x,tile.y,0,0.5,0.5)
		end
		if tile.id == 5 and tile.exist then
			love.graphics.setColor(142,86,48,255)
			love.graphics.draw(linesImg,tile.x,tile.y,0,0.5,0.5)
		end
		
		--rLaser line
		for i, tile in pairs(tiles) do
		if tile.id == 100 then
			if tile.sdir > 0 then
				love.graphics.setColor(255,0,0)
				love.graphics.line(tile.x + 20, tile.y + 20, player.x+10,player.y+10)
			end
		end
	end
	
	
		
		

		
		--EnemyTiles
		if tile.id == 100 then
			love.graphics.setColor(tile.color)
			love.graphics.draw(laserRocketImg,tile.x,tile.y,0,0.5,0.5)
			
			--line
			if tile.sdir > 0 then
				if tile.obst then
					love.graphics.setColor(255,255/2,0,255)
				else
					love.graphics.setColor(255,0,0,255)
				end
			--	love.graphics.line(tile.x + 20, tile.y + 20, player.x+10,player.y+10)
			end
			

		end
		if tile.id == 100.1 then
			love.graphics.setColor(255,0,0,255)
			love.graphics.rectangle('fill',tile.x,tile.y,40,40)
		end
		if tile.id == 101 then
			love.graphics.setColor(tile.color)
			love.graphics.draw(machinegunImg,tile.x,tile.y,0,0.5,0.5)
		end
		if tile.id == 102 then
			love.graphics.setColor(tile.color)
			love.graphics.draw(homingImg,tile.x,tile.y,0,0.5,0.5)
		end
	end
	
	
	--Draw Player
		if menu.page > 1 or menu.page < 1 then
			if level.current > 0 and level.current < 27 then
				love.graphics.setColor(255,255,255,255)
				love.graphics.draw(playerImg, player.x, player.y, 0, 1, 1)
			end
		end
	
	--Draw boxes
	for i, box in pairs(boxes) do
		love.graphics.setColor(0,0,0)
		love.graphics.rectangle('fill',box.x,box.y,box.width,box.height)
	end
	
	--Draw Controls
	if level.current == 1 then
		love.graphics.setFont(f_lun)
		
		love.graphics.print('Controls',1280/2-48, 100, 0, 0.1, 0.1)
		
		if love.keyboard.isDown('a') then
			love.graphics.setColor(100,100,200)
		else
			love.graphics.setColor(255,255,255)
		end
		love.graphics.draw(keyBImg,1280/2-(keyBImg:getWidth()), 200)
		love.graphics.print('A',1280/2-(keyBImg:getWidth())+20, 200+12.5, 0, 0.1,0.1)
		
		if love.keyboard.isDown('d') then
			love.graphics.setColor(100,100,200)
		else
			love.graphics.setColor(255,255,255)
		end
		love.graphics.draw(keyBImg,1280/2+(keyBImg:getWidth()), 200)
		love.graphics.print('D',1280/2+(keyBImg:getWidth())+22, 200+12.5, 0, 0.1,0.1)
		
		if love.keyboard.isDown('w') then
			love.graphics.setColor(100,100,200)
		else
			love.graphics.setColor(255,255,255)
		end
		love.graphics.draw(keyBImg,1280/2, 200-keyBImg:getHeight())
		love.graphics.print('W',1280/2+22, 200-keyBImg:getHeight()+12.5, 0, 0.1,0.1)
	end
	
	--Draw Menus--
	
	--draw ending
	love.graphics.setFont(f_lun)
	love.graphics.setColor(255,255,255)
	love.graphics.draw(logoImg,1280/2-(logoImg:getWidth()/4),creditsY,0,0.5,0.5)
	love.graphics.setColor(255,255,255)
	love.graphics.print('Programming by:',1280/2-310,creditsY+300,0,0.1,0.1)
	love.graphics.setColor(150,100,100)
	love.graphics.print('HydrogenManiac',1280/2,creditsY+300,0,0.1,0.1)
	love.graphics.print('HydrogenManiac',1280/2-80,creditsY+350,0,0.1,0.1)
	love.graphics.setColor(255,255,255)
	love.graphics.print('Visuals by:',1280/2-310,creditsY+350,0,0.1,0.1)
	love.graphics.setColor(255,255,255)
	love.graphics.print('Music by:',1280/2-310,creditsY+400,0,0.1,0.1)
	love.graphics.setColor(100,100,150)
	love.graphics.print('Fantomenk',1280/2-125,creditsY+400,0,0.1,0.1)
	
	--draw main menu
	if menu.page == 1 then
		spawn.x = 5000
		endgate.x = 7000
		
		love.graphics.setFont(f_lun)
		
		love.graphics.setColor(255,255,255)
		love.graphics.draw(logoImg,1280-(logoImg:getWidth()/1.525), 0, 0, 0.5, 0.5)
		
		if menu.selected == 1 then
			love.graphics.setColor(0,255,0)
		else
			love.graphics.setColor(255,255,255)
		end
		x = love.filesystem.read('level.txt')
		if love.filesystem.exists('level.txt') and tonumber(x) == 27 then
			love.graphics.print('Restart', 1280/2-(70), 310, 0, 0.125, 0.125)
			love.graphics.draw(buttonImg, 1280/2-(buttonImg:getWidth()/4.5), 300, 0, 0.5, 0.5)
		elseif love.filesystem.exists('level.txt') and tonumber(x) > 1 and tonumber(x) < 27 then
			love.graphics.print('Continue', 1280/2-(83), 310, 0, 0.125, 0.125)
			love.graphics.draw(buttonImg, 1280/2-(buttonImg:getWidth()/4.5), 300, 0, 0.5, 0.5)
		else
			love.graphics.print('Start', 1280/2-(40), 310, 0, 0.125, 0.125)
			love.graphics.draw(buttonImg, 1280/2-(buttonImg:getWidth()/4.5), 300, 0, 0.5, 0.5)
		end
		
		if menu.selected == 2 then
			love.graphics.setColor(0,140,255)
		else
			love.graphics.setColor(255,255,255)
		end
		love.graphics.print('Options', 1280/2-(70), 410, 0, 0.125, 0.125)
		love.graphics.draw(buttonImg, 1280/2-(buttonImg:getWidth()/4.5), 400, 0, 0.5, 0.5)
		
		if menu.selected == 3 then
			love.graphics.setColor(255,0,0)
		else
			love.graphics.setColor(255,255,255)
		end
		love.graphics.print('Quit', 1280/2-(30), 510, 0, 0.125, 0.125)
		love.graphics.draw(buttonImg, 1280/2-(buttonImg:getWidth()/4.5), 500, 0, 0.5, 0.5)
		
	end
	
	--draw option menu
	if menu.page == 2 then
		
		options.masterVolume = tonumber(options.masterVolume)
		love.graphics.setFont(f_rog)
	
		love.graphics.setColor(0,0,0,200) --translucent bg
		love.graphics.rectangle('fill',0,0,1280,720)
	
		drawBackground()
	
		love.graphics.setColor(255,255,255)	--fullscreen box
		love.graphics.rectangle('fill', 100,100,60,60)
		love.graphics.setColor(20,20,20)
		love.graphics.rectangle('fill', 100+2.5,100+2.5,60-5,60-5)
		love.graphics.setColor(255,255,255)
		love.graphics.print('Fullscreen', 175,100, 0, 0.25,0.25)
		if fullscreen then
			love.graphics.setColor(255,255,255)
			love.graphics.rectangle('fill', 100+7.5,100+7.5,60-15,60-15)
		end
		
		love.graphics.setColor(255,255,255)	--particles box
		love.graphics.rectangle('fill', 100,200,60,60)
		love.graphics.setColor(20,20,20)
		love.graphics.rectangle('fill', 100+2.5,200+2.5,60-5,60-5)
		love.graphics.setColor(255,255,255)
		love.graphics.print('Particles', 175,200, 0, 0.25,0.25)
		if options.particles then
			love.graphics.setColor(255,255,255)
			love.graphics.rectangle('fill', 100+7.5,200+7.5,60-15,60-15)
		end
		
		love.graphics.setColor(255,255,255) --mastervolume buttons
		love.graphics.draw(plusminusImg,100,300)
		love.graphics.setColor(255,255,255)
		if options.masterVolume == 0 then
			love.graphics.print('0.0', 140,300, 0, 0.25,0.25)
		elseif options.masterVolume > 0.9 then
			love.graphics.print('1.0', 140,300, 0, 0.25,0.25)
		else
			love.graphics.print(options.masterVolume, 140,300, 0, 0.25,0.25)
		end
		love.graphics.print('MasterVolume', 275,300, 0, 0.25,0.25)
		
		love.graphics.setColor(255,255,255)	--musicVolume
		love.graphics.draw(plusminusImg, 100, 400)
		love.graphics.setColor(255,255,255)
		if options.musicVolume == 0 then
			love.graphics.print('0.0', 140,400, 0, 0.25,0.25)
		elseif options.musicVolume > 0.9 then
			love.graphics.print('1.0', 140,400, 0, 0.25,0.25)
		else
			love.graphics.print(options.musicVolume,140,400,0,0.25,0.25)
		end
		love.graphics.print('MusicVolume', 275,400,0,0.25,0.25)
		
		
		--back button
		love.graphics.setFont(f_lun)
		if menu.selected == 1 then
			love.graphics.setColor(255,0,0)
		else
			love.graphics.setColor(255,255,255)
		end
		love.graphics.print('Back', 215, 610, 0, 0.125, 0.125)
		love.graphics.draw(buttonImg, 100, 600, 0, 0.5, 0.5)
		
	end
	
	
	
	--Draw cursor
	if menu.page > 0 then
		love.graphics.setColor(255,255,255)
		love.graphics.draw(cursorImg,love.mouse.getX(),love.mouse.getY(),0,0.1,0.1)
	end
	
	
	
	--Draw DevInfo
	if options.info then
	
		love.graphics.setFont(f_dv)
	
		love.graphics.setColor(255,255,255,255)
		love.graphics.print('FPS: '..love.timer.getFPS(),10,10)
		love.graphics.setColor(255,255,255,255)
		love.graphics.print('Current Level: '..level.current,10,20)
		love.graphics.setColor(255,255,255,255)
		love.graphics.print('--OptionStuff--',10,35)
		if fullscreen then
			love.graphics.setColor(0,255,0,255)
		else
			love.graphics.setColor(255,0,0,255)
		end
		love.graphics.print('Fullscreen: '..tostring(fullscreen),10,50)
		if options.particles then
			love.graphics.setColor(0,255,0,255)
		else
			love.graphics.setColor(255,0,0,255)
		end
		love.graphics.print('Particles: '..tostring(options.particles),10,60)
	end
	
	
	transi()
	
end
